SystemOrganization addCategory: #'SUnit-UITesting'!

UITestCase subclass: #SimulateKeystrokesSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateCmdKeystroke

	| ws |
	ws := Workspace open.
	self simulateKeyStrokes: 'var := 3.'.
	self simulateKeyStroke: $s command.
	self assert: ws hasUnacceptedEdits = false.
	ws dependents first delete.! !

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateKeystroke

	| textMorph |
	textMorph := TextMorph new contents: ''; openInWorld.
	textMorph takeKeyboardFocus.
	self simulateKeyStroke: $s.
	self assert: textMorph contents = 's'.
	textMorph delete.! !

!SimulateKeystrokesSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:04'!
testSimulateKeystrokes

	| textMorph |
	textMorph := TextMorph new contents: ''; openInWorld.
	textMorph takeKeyboardFocus.
	self simulateKeyStrokes: 'hello'.
	self assert: textMorph contents = 'hello'.
	textMorph delete.! !

UITestCase subclass: #SimulateMouseSpecification
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/14/2011 14:07'!
menuOpenedDuring: aBlock

	| jailor |
	jailor := MenuCapturingMorph new openInWorld.
	aBlock value.
	^ jailor menu.! !

!SimulateMouseSpecification methodsFor: 'running' stamp: 'SeanDeNigris 12/14/2011 14:05'!
tearDown

	morph delete.! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:01'!
testSimulateClick
	"self run: #testSimulateClick"

	morph := TextMorph new contents: ''; openInWorld.	
	morph simulateClick.
	self assert: morph hasKeyboardFocus.! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:02'!
testSimulateRightClick
	"self run: #testSimulateRightClick"
	
	| workspace menu sem before after |
	workspace := Workspace open.
	morph := self waitForMorphThat: [ :its | its model == workspace ].
	menu := self menuOpenedDuring: [ morph simulateRightClick ].
	self assert: menu isNil not.! !

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/9/2011 17:37'!
timeoutAfter: aDuration ifNot: aBlock

	| timer |
	timer := Stopwatch new activate.
	[ timer duration < aDuration and: [ aBlock value not ] ] whileTrue.! !

!SimulateMouseSpecification methodsFor: 'helpers' stamp: 'SeanDeNigris 12/14/2011 13:57'!
waitForMorphThat: aBlock

	[
		morph := World submorphThat: aBlock ifNone: [ nil ].
		(Delay forMilliseconds: 100) wait.
		morph isNil ] whileTrue.
	^ morph.! !

!SimulateMouseSpecification methodsFor: 'tests' stamp: 'StephaneDucasse 11/2/2012 11:55'!
zorktestSimulateMiddleClick
	"self run: #testSimulateMiddleClick"
	
	self flag: #forSean. "this test randomly fails"
	morph := MorphHandlingMiddleButton new openInWorld.
	morph simulateMiddleClick.
	self assert: morph wasClickedWithMiddleButton.
! !

Morph subclass: #MenuCaptureMorph
	instanceVariableNames: 'worldBefore timeout timer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MenuCaptureMorph class methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 12/9/2011 21:19'!
timingOutAfter: aDuration

	^ (self new setTimeout: aDuration) openInWorld.! !

!MenuCaptureMorph methodsFor: 'initialize' stamp: 'SeanDeNigris 12/9/2011 21:20'!
initialize

	worldBefore := World submorphs.
	timer := Stopwatch new activate.! !

!MenuCaptureMorph methodsFor: 'stepping' stamp: 'SeanDeNigris 12/9/2011 21:19'!
setTimeout: aDuration

	timeout := aDuration.
	^ self.! !

!MenuCaptureMorph methodsFor: 'stepping' stamp: 'SeanDeNigris 12/9/2011 21:12'!
step

	Transcript show: 'moving'.! !

Morph subclass: #MenuCapturingMorph
	instanceVariableNames: 'menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MenuCapturingMorph methodsFor: 'menu' stamp: 'SeanDeNigris 12/14/2011 14:06'!
menu

	^ menu.! !

!MenuCapturingMorph methodsFor: 'stepping and presenter' stamp: 'SeanDeNigris 12/14/2011 14:08'!
step

	menu := World submorphs detect: [ :m | m isKindOf: MenuMorph ] ifNone: [ menu ].
	menu isNil ifFalse: [ 
		menu delete.
		self delete ].! !

!Morph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 12/1/2011 22:08'!
simulateClick

	self simulateClickWith: MouseEvent redButton.! !

!Morph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 12/9/2011 14:07'!
simulateClickWith: buttons
	"Did you know there's #simulateClick (left), #simulateMiddleClick, and #simulateRightClick?
	buttons - look at MouseEvent's class-side for button types"

	| noButtons |
	noButtons := 0.
	{ #mouseDown->buttons. #mouseUp->noButtons } do: [ :type |
		self activeHand handleEvent: (MouseButtonEvent new 
			setType: type key
			position: (self pointInWorld: self center) "Some Morphs report local coords"
			which: (noButtons bitXor: buttons)
			buttons: type value
			hand: self activeHand
			stamp: Time millisecondClockValue) ].! !

!Morph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 12/9/2011 13:56'!
simulateMiddleClick

	self simulateClickWith: MouseEvent blueButton.! !

!Morph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 12/1/2011 22:08'!
simulateRightClick

	self simulateClickWith: MouseEvent yellowButton.! !

Morph subclass: #MorphHandlingMiddleButton
	instanceVariableNames: 'menu receivedBlueButtonUp receivedBlueButtonDown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UITesting'!

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:18'!
blueButtonDown: anEvent

	receivedBlueButtonDown := true.! !

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:18'!
blueButtonUp: anEvent

	receivedBlueButtonUp := true.! !

!MorphHandlingMiddleButton methodsFor: 'meta-actions' stamp: 'SeanDeNigris 12/14/2011 15:17'!
handlerForBlueButtonDown: anEvent

	^ self.! !

!MorphHandlingMiddleButton methodsFor: 'initialization' stamp: 'SeanDeNigris 12/14/2011 15:24'!
initialize

	super initialize.
	receivedBlueButtonUp := receivedBlueButtonDown := false.! !

!MorphHandlingMiddleButton methodsFor: 'testing' stamp: 'SeanDeNigris 12/14/2011 15:21'!
wasClickedWithMiddleButton

	^ receivedBlueButtonDown and: [ receivedBlueButtonUp ].! !

!TestCase methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 11/22/2011 18:58'!
simulateKeyStroke: aCharacterOrShortcut

	ActiveHand simulateKeyStroke: aCharacterOrShortcut.! !

!TestCase methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 11/22/2011 18:19'!
simulateKeyStrokes: aString 

	ActiveHand simulateKeyStrokes: aString.! !

!MenuMorph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 12/1/2011 22:47'!
choose: aString 

	| item |
	item := self itemWithWording: aString.
	item ifNil: [ self error: 'Menu does not have "', aString, '" item' ].
	item simulateClick.! !

!Workspace methodsFor: '*SUnit-UITesting' stamp: 'StephaneDucasse 11/2/2012 11:08'!
hasUnacceptedEdits
	"Answer true if any of the views on this model has unaccepted edits."

	self dependents
		do: [:each | 
			self flag: #fixMe. "The check for #respondsTo: is a hack necessary just because the old
			Browser uses it wrong. We need to change this after old Browser removal"
			((each respondsTo: #hasUnacceptedEdits) and: [ each hasUnacceptedEdits ]) 
				ifTrue: [^ true]]
		without: self.
	^ false
! !

!HandMorph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 11/22/2011 18:57'!
simulateKeyStroke: aCharacterOrShortcut

	| shortcut |
	shortcut := aCharacterOrShortcut asShortcut.
	self handleEvent: (KeyboardEvent new
		setType: #keystroke
		buttons: shortcut modifier eventCode
		position: self position 
		keyValue: shortcut key asciiValue
		charCode: shortcut key asciiValue
		hand: self activeHand 
		stamp: DateAndTime now).! !

!HandMorph methodsFor: '*SUnit-UITesting' stamp: 'SeanDeNigris 11/22/2011 18:56'!
simulateKeyStrokes: aString

	aString do: [ :c | self simulateKeyStroke: c ].! !
